#include 	<avr/io.h>
#include 	<avr/interrupt.h>
#include 	<avr/pgmspace.h>
#include 	<stdio.h>
#include 	<stdarg.h>
#include 	<string.h>
#include 	<stdlib.h>
#include	<math.h>

#include 	"mydefs.h"

#include 	"serial.h"
#include 	"printf.h"

//-------------------------------------------------------------------------//
#define 	pull_R 			(float)10000.0 	// r pullup 10 K Ohm
#define 	RREF 			(float)10000.0  // value of at 25 degrees
#define 	BVALUE 			(float)3435.0 	// from datasheet ntc

double  	temperature[5];
//-------------------------------------------------------------------------//
#define 	NONE			1000
//---------------------------------------------------------------------------------//
void init_adc (void)
{
   ADCSRA 	|= (_BV(ADPS2)| _BV(ADPS1)|_BV(ADPS0));   //16Mhz/128 = 125Khz
   ADMUX 	|= _BV(REFS0);			   
   ADCSRA 	|= _BV(ADEN);			   
   ADCSRA 	|= _BV(ADSC);	
}
//---------------------------------------------------------------------------------//
uint16_t read_adc (char channel)
{
	ADMUX 	&= 0xF0; 
	ADMUX 	|= channel; 
	ADCSRA  |= (1<<ADSC); 
		while(ADCSRA & (1<<ADSC)); 
	return ADCW; 
}
//---------------------------------------------------------------------------------//
double fCalcNtc (uint16_t dat)
{ 
	return  (pull_R *  (double)dat / (1023.0  - (double) dat));  // 10000 =  pullup resistor   =10K
}
//---------------------------------------------------------------------------------//
double fCalcTemp	(double fRntc)
{
	return (10.0/((log(fRntc/RREF))/BVALUE  + 1.0/298.0)) - 2730.0; //log = ln
}
//---------------------------------------------------------------------------------//
//-------------------------------------------------------------------------//
uint16_t read_Temp (void)
{
	uint16_t 	adcvalue;
	double 		r_value;
	uint16_t	temperature;
		
			adcvalue = read_adc (0);
			
			if (adcvalue < 1000)
			{
				r_value = fCalcNtc			(adcvalue);
				temperature = fCalcTemp 	(r_value);
				//temperature;// = (double)(temperature/10.0);
			}
			else
				temperature = 999;
	return  temperature;
}
//---------------------------------------------------------------------------------//
//---------------------------------------------------------------------------------//
//---------------------------------------------------------------------------------//
