#ifndef ___SERIAL_H
#define ___SERIAL_H

#include <avr/pgmspace.h>

#define UART_BAUD_RATE     9600

#define UART_BAUD_SELECT (F_CPU/(UART_BAUD_RATE*16l)-1)

extern void ser_init	(void);
extern void ser_putc	(uint8_t c);
extern void ser_puts	(uint8_t *s);
extern int ser_gets		(uint8_t *s, uint8_t len);
extern unsigned char 	ser_getc (void);
extern void ser_puthex	(uint8_t by);

extern volatile uint8_t rcnt, rpos;
extern volatile uint8_t busy;

extern void _serputs_P(char const *txt);
#define serputs_P(text)   _serputs_P(PSTR(text))

#define TX0_BIT							1
#define TX0_PORT						PORTD
#define TX0_DDR							DDRD

//#define SIG_UART_RECEIVE				SIG_UART_RECV
//#define SIG_UART_TRANSMIT				SIG_UART0_TRANS

#define UART0_RECEIVE_REGISTER    		UDR0
#define UART0_TRANSMIT_REGISTER   		UDR0

#define ENABLE_UART0_TRANSMIT_INT		UCSR0B |= _BV(TXEN0)  // 
#define DISABLE_UART0_TRANSMIT_INT		UCSR0B &= ~_BV(TXEN0)  // 

#define ENABLE_UART0_RECEIVE_INT		UCSR0B |= _BV(RXCIE0)
#define DISABLE_UART0_RECEIVE_INT		UCSR0B &= ~_BV(RXCIE0)

#define UART0_BAUD_REGISTER_HIGH		UBRR0H
#define UART0_BAUD_REGISTER_LOW			UBRR0L

#define UART0_CONFIGURE1				UCSR0B= _BV(RXCIE0) | _BV(TXCIE0) | _BV(RXEN0) | _BV(TXEN0)
#define UART0_CONFIGURE2				UCSR0C= _BV(UCSZ01) | _BV(UCSZ00) //8 Bit,1 Stop, no parity
  
#endif
